<?php

include_once("da_sa_smo_club.php");

class Sa_smo_club_model extends Da_sa_smo_club {

	/*
	 * aOrderBy = array('fieldname' => 'ASC|DESC', ... )
	 */
	function get_all($aOrderBy=""){
		$orderBy = "";
		if ( is_array($aOrderBy) ) {
			$orderBy.= "ORDER BY "; 
			foreach ($aOrderBy as $key => $value) {
				$orderBy.= "$key $value, ";
			}
			$orderBy = substr($orderBy, 0, strlen($orderBy)-2);
		}
		$sql = "SELECT * 
				FROM $this->sa_dbname.sa_smo_club 
				$orderBy";
		$query = $this->db->query($sql);
		return $query;
	}
	
	/*
	 * create array of pk field and value for generate select list in view, must edit PK_FIELD and FIELD_NAME manually
	 * the first line of select list is '-----เลือก-----' by default.
	 * if you do not need the first list of select list is '-----เลือก-----', please pass $optional parameter to other values. 
	 * you can delete this function if it not necessary.
	 */
	function get_options($optional='y') {
		$opt = array();
		$qry = $this->get_all(array('sc_name' => 'ASC'));
		if ($optional=='y') $opt[''] = '-----เลือก-----';
		foreach ($qry->result() as $row) {
			$opt[$row->sc_id] = $row->sc_name;
		}
		return $opt;
	}
	
	function get_optionsByType($optional='y') {
		$opt = array();
		$qry = $this->get_by_type();
		if ($optional=='y' ) $opt[''] = '-----เลือก-----';
		foreach ($qry->result() as $row) {
			$opt[$row->sc_id] = $row->sc_name.'&nbsp;';
		}
		return $opt;
	}
	
	// add your functions here

	function get_by_type($withSetAttributeValue=FALSE) {
		$sql = "SELECT * 
				FROM $this->sa_dbname.sa_smo_club 
				WHERE sc_type=?";
		$query = $this->db->query($sql, array($this->sc_type));
		if ( $withSetAttributeValue ) {
			$this->row2attribute( $query->row() );
		} else {
			return $query ;
		}
	}
	
	function get_by_type_PR($withSetAttributeValue=FALSE) {
		$sql = "SELECT * 
				FROM $this->sa_dbname.sa_smo_club 
				WHERE sc_parentId =? and sc_type=? ";
		$query = $this->db->query($sql, array($this->sc_parentId,$this->sc_type));
		if ( $withSetAttributeValue ) {
			$this->row2attribute( $query->row() );
		} else {
			return $query ;
		}
	}

    function get_optionsByTypePR($optional='y') {
        $qry = $this->get_by_type_PR();
        if ($optional=='y' ) $opt[''] = '-----เลือก-----';
        foreach ($qry->result() as $row) {
            $opt[$row->sc_id] = $row->sc_name.'&nbsp;';
        }
        return $opt;
    }

	function get_by_group($withSetAttributeValue=FALSE) {
		$sql = "SELECT * 
				FROM $this->sa_dbname.sa_smo_club 
				WHERE sc_fup_grp=?";
		$query = $this->db->query($sql, array($this->sc_fup_grp));
		if ( $withSetAttributeValue ) {
			$this->row2attribute( $query->row() );
		} else {
			return $query ;
		}
	}

    function get_position(){
        $con = '';
        $con.=($this->sc_id!='')?" AND sc_id = $this->sc_id ":'';
        $sql =  "SELECT *
            FROM $this->sa_dbname.sa_smo_club 
            LEFT JOIN $this->sa_dbname.sa_position ON sc_type = pos_type
            WHERE 1=1 AND pos_status = 'Y' 
            $con
            ORDER BY pos_seq ";
        $query = $this->db->query($sql);
        return $query;
    }


	function check_rep_name() {
		($this->sc_id == '') ? $cond = '' : $cond = "AND sc_id <> $this->sc_id";
		$sql = "SELECT * 
				FROM $this->sa_dbname.sa_smo_club
				WHERE sc_name = ? AND sc_parentId = ? $cond";
		$query = $this->db->query($sql,array($this->sc_name, $this->sc_parentId));
		return $query;
	}

	function get_by_dpj($dpj_id) {
		$sql = "SELECT * 
				FROM $this->sa_dbname.sa_smo_club
				INNER JOIN $this->sa_dbname.sa_target_group 
				WHERE tg_dpj_id = ?";
		$query = $this->db->query($sql,array($dpj_id));
		return $query;
	}

	function get_all_by_key($withSetAttributeValue=FALSE) {
		$sql = "SELECT club.*, smo.sc_name as parent_name
				FROM $this->sa_dbname.sa_smo_club club
				INNER JOIN $this->sa_dbname.sa_smo_club smo ON smo.sc_id = club.sc_parentId
				WHERE club.sc_id=?";
		$query = $this->db->query($sql, array($this->sc_id));

		if ( $withSetAttributeValue ) {
			$this->row2attribute( $query->row() );
		} else {
			return $query ;
		}
	}
    
} // end class Sa_smo_club_model
?>